// FILin fileechoprocessor
// Copyright (c) 1995-99 Ilya Bogdanov
// See licence.txt for details

#include "fidoaddr.h"
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>

int checkaddr(
        char *f )
{
        while( *f && *f != '@' )
        {
        if( isspace( *f ) ) break;
        if( !isdigit( *f ) && *f != ':' && *f != '/' && *f != '.' ) return 0;
        f++;
        }
        return 1;
}

char* addrtostr (struct sAddr* from)
{
  static char tempaddr[ADDRLEN];
  if (from->point)
    sprintf(tempaddr,"%u:%u/%u.%u",from->zone,from->net,from->node,from->point);
  else
    sprintf(tempaddr,"%u:%u/%u",from->zone,from->net,from->node);
  return tempaddr;
}

int parseaddr(
        struct sAddr    *to,
    char                        *from,
    struct sAddr        *def )
{
        char                    *f1;
        if( !checkaddr( from ) ) return 0;
        to->zone = def->zone;
    to->net = def->net;
    to->node = def->node;
    to->point = 0;
        switch( *from )
    {
        case '/':
            to->node = atoi( from + 1 );
            break;
        case '0': case '1': case '2': case '3': case '4':
        case '5': case '6': case '7': case '8': case '9':
                if( f1 = strchr( from, ':' ) )
            {
                to->zone = atoi( from );
                to->net = atoi( f1 + 1 );
                if( !( f1 = strchr( f1, '/' ) ) ) return 0;
                to->node = atoi( f1 + 1 );
            }
            else
                if( f1 = strchr( from, '/' ) )
                {
                  to->net = atoi( from );
                  to->node = atoi( f1 + 1 );
                }
                else
                  to->node = atoi( from );
        }
    if( f1 = strchr( from, '.' ) ) to->point = atoi( f1 + 1 );
        return to->zone;
}

char* shrtaddr (char* to, struct sAddr* from, struct sAddr* ad)
{
  if (from->zone != ad->zone) {
    if (from->point) sprintf(to,"%u:%u/%u.%u",from->zone,from->net,from->node,from->point);
    else sprintf(to,"%u:%u/%u",from->zone,from->net,from->node);
  }
  else if (from->net != ad->net) {
    if (from->point) sprintf(to,"%u/%u.%u",from->net,from->node,from->point);
    else sprintf(to,"%u/%u",from->net,from->node);
  }
  else if (from->node != ad->node) {
    if (from->point) sprintf(to,"%u.%u",from->node,from->point);
    else sprintf(to,"%u",from->node);
  }
  else sprintf(to,".%u",from->point);
  return to;
}

int addrcmp(
        struct sAddr* a1,
    struct sAddr* a2 )
{
        return ( a1->zone == a2->zone && a1->net == a2->net
        && a1->node == a2->node && a1->point == a2->point );
}

/*
void main(
        int                     argc,
    char                        *argv[] )
{
        struct sAddr    addr, la = { 2, 5030, 184, 0 };
    if( argc > 1 )
    {
            if( parseaddr( &addr, argv[1], &la ) )
                printf( "%s -> %s\n", argv[1], addrtostr( &addr ) );
        else
            printf( "%s is not a valid address", argv[1], addrtostr( &addr ) );
    }
}
*/
