// FILin fileechoprocessor
// Copyright (c) 1995-99 Ilya Bogdanov
// See licence.txt for details

#include "general.h"
#include "tic.h"

struct Sticline* ticlines;

int newtic;
int newget;

void putticline (char* line)
{
  static struct Sticline* temp;

  if (newtic)
  {
    temp = (ticlines == NULL)
      ? ticlines = (struct Sticline *) calloc(1,sizeof(struct Sticline))
      : ticlines;
    newtic = 0;
  }
  else
    temp = (temp->next == NULL)
      ? temp->next = (struct Sticline *) calloc(1,sizeof(struct Sticline))
      : temp->next;
  if (temp == NULL) errexit(3,"putticline");
  strcpy(temp->line,line);
  if (temp->next) *temp->next->line = 0;
}

char* getticline (void)
{
  static struct Sticline* temp;

  if (newget)
  {
    temp = ticlines;
    newget = 0;
  }
  else temp = temp->next;
  return (!temp || !*temp->line) ? NULL : temp->line;
}

void load_tic (void)
{
  FILE* tic;
  char line[TICLINE];
  struct sAddr temp;
  int j = 0,k,save = 1,desc = 0;

  free(in.desc);
  memset(&in,0,sizeof(in));
  if ((tic = fopen(ticfull,"rt")) == NULL)
  {
    logout(stdout,'?',"Cannot open file %s",ticfull);
    return;
  }
  newtic = 1;
  while (fgets(line,TICLINE,tic) != NULL)
  {
    if (!strnicmp(line,"Area ",5))
#ifndef _UNIX_
      strupr(
#endif
            wordcpy(in.area,word(line,1),TAGLEN)
#ifndef _UNIX_
        )
#endif
            ;
    else if (!strnicmp(line,"File ",5))
#ifndef _UNIX_
      strupr(
#endif
        wordcpy(in.file,word(line,1),FILELEN)
#ifndef _UNIX_
        )
#endif
        ;
    else if (!strnicmp(line,"Desc ",5))
    {
      if (!desc)                           // 1st Desc goes to files.bbs
      {
        in.desc = (char*)calloc(strlen(line)-4,1);
        strcpy(in.desc,word(line,1));
        LASTCHAR(in.desc) = 0;             // skip \n at the end
        desc = 1;
      }
    }
    else if (!strnicmp(line,"LDesc ",6));
    else if (!strnicmp(line,"Size ",5))
      in.size = atol(word(line,1));
    else if (!strnicmp(line,"Crc ",4))
      wordcpy(in.crc,word(line,1),9);
    else if (!strnicmp(line,"Magic ",6))
      wordcpy(in.magic,word(line,1),MAGICLEN);
    else if (!strnicmp(line,"Replaces ",9))
      wordcpy(in.repl,word(line,1),FILELEN);
    else if (!strnicmp(line,"Origin ",7))
      wordcpy(in.origin,word(line,1),ADDRLEN);
    else if (!strnicmp(line,"Path ",5));
    else if (!strnicmp(line,"Seenby ",7))
       {
       parseaddr(&temp,word(line,1),&la);
       if ((seenby[j] = islink(&temp)) != NULL)
          {
          for (k = 0; k < j && seenby[k] != seenby[j]; k++);
          if (k == j) j++;
          }
       }
    else if (!strnicmp(line,"From ",5))
    {
      parseaddr(&in.from,word(line,1),&la);
      seenby[j] = islink(&in.from);
      for (k = 0; k < j && seenby[k] != seenby[j]; k++);
      if (k == j) j++;
      save = 0;
    }
    else if (!strnicmp(line,"Pw ",3))
    {
      wordcpy(in.pass,word(line,1),PASSLEN);
      save = 0;
    }
    else if (!strnicmp(line,"To ",3))
    {
        parseaddr(&in.to,word(line,1),&la);
        save = 0;
    }
    else save = 0;
    if (save) putticline(line);
    else save = 1;
  }
  fclose(tic);
}
